<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22"><span>物流公司信息列表</span> </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:logisticsCompany:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>

      <el-table v-loading="loading" border :data="logisticsCompanyList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <!-- <el-table-column label="编号" align="center" prop="logisticsNo" /> -->
        <el-table-column label="编码" align="center" prop="logisticsCode" />
        <el-table-column label="名称" align="center" prop="logisticsName" />
        <el-table-column label="描述" align="center" prop="logisticsDescription" />
        <el-table-column label="状态" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.isShow" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <!-- <el-table-column label="数据来源" align="center" prop="dataSource" /> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:logisticsCompany:edit']">编辑</el-button>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改物流公司对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="600px" append-to-body>
      <el-form ref="logisticsCompanyFormRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="名称" prop="logisticsName">
          <el-input v-model="form.logisticsName" placeholder="请输入物流公司名称" />
        </el-form-item>
        <el-form-item label="编码" prop="logisticsCode">
          <el-input v-model="form.logisticsCode" placeholder="请输入物流公司编码" />
        </el-form-item>
        <el-form-item label="描述" prop="logisticsDescription">
          <el-input v-model="form.logisticsDescription" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-form-item label="是否显示" prop="isShow">
          <el-radio-group v-model="form.isShow">
            <el-radio v-for="dict in sys_platform_yes_no" :key="dict.value" :value="dict.value">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="LogisticsCompany" lang="ts">
import {
  listLogisticsCompany,
  getLogisticsCompany,
  delLogisticsCompany,
  addLogisticsCompany,
  updateLogisticsCompany,
  changeStatus
} from '@/api/company/logisticsCompany';
import { LogisticsCompanyVO, LogisticsCompanyQuery, LogisticsCompanyForm } from '@/api/company/logisticsCompany/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { sys_platform_yes_no } = toRefs<any>(proxy?.useDict('sys_platform_yes_no'));

const logisticsCompanyList = ref<LogisticsCompanyVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const logisticsCompanyFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: LogisticsCompanyForm = {
  id: undefined,
  logisticsNo: undefined,
  logisticsCode: undefined,
  logisticsName: undefined,
  logisticsDescription: undefined,
  isShow: '0',
  dataSource: undefined,
  remark: undefined
};
const data = reactive<PageData<LogisticsCompanyForm, LogisticsCompanyQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    logisticsCode: undefined,
    logisticsName: undefined,
    logisticsDescription: undefined,
    isShow: undefined,
    dataSource: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    logisticsName: [{ required: true, message: '物流公司名称不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询物流公司列表 */
const getList = async () => {
  loading.value = true;
  const res = await listLogisticsCompany(queryParams.value);
  logisticsCompanyList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  logisticsCompanyFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

const handleStatusChange = async (row: LogisticsCompanyVO) => {
  const oldValue = row.isShow; // 保存旧值（0 或 1）

  try {
    await changeStatus(row.id, row.isShow); // 传新值
    proxy?.$modal.msgSuccess('操作成功');
  } catch {
    row.isShow = oldValue; // 失败回滚
    proxy?.$modal.msgError('操作失败，请重试');
  }
};
/** 多选框选中数据 */
const handleSelectionChange = (selection: LogisticsCompanyVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加物流公司';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: LogisticsCompanyVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getLogisticsCompany(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改物流公司';
};

/** 提交按钮 */
const submitForm = () => {
  logisticsCompanyFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateLogisticsCompany(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addLogisticsCompany(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: LogisticsCompanyVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除物流公司编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delLogisticsCompany(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/logisticsCompany/export',
    {
      ...queryParams.value
    },
    `logisticsCompany_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
